﻿using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls.Map;

namespace GeometryCollectionGrouping
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void AsyncSqlGeospatialDataReader_PreviewReadShapeDataCompleted(object sender, PreviewReadShapeDataCompletedEventArgs e)
        {
            // e.Items
            // contains the shapes which are generated by the SqlGeospatialDataReader
            // e.Items[0] is the Telerik.Windows.Controls.Map.PathData which contains 3 polygons of North Area
            // e.Items[1] and e.Items[2] are the Telerik.Windows.Controls.Map.PolygonData of GeometryCollection of South Area
        }

        private void visualizationLayer_MapShapeVisualizationCreated(object sender, MapShapeOperationEventArgs e)
        {
            e.Visualization.MouseEnter += Visualization_MouseEnter;
            e.Visualization.MouseLeave += Visualization_MouseLeave;
        }

        void Visualization_MouseEnter(object sender, MouseEventArgs e)
        {
            FrameworkElement element = sender as FrameworkElement;
            if (element != null)
            {
                MapShapeData shape = element.DataContext as MapShapeData;
                if (shape != null && shape.ExtendedData != null)
                {
                    string areaName = (string)shape.ExtendedData.GetValue("Name");

                    IEnumerable<object> itemsToSelect = from MapShapeData item in this.visualizationLayer.Items
                                                        where (string)item.ExtendedData.GetValue("Name") == areaName
                                                        select item;

                    this.visualizationLayer.Select(itemsToSelect, true);
                }
            }
        }

        void Visualization_MouseLeave(object sender, MouseEventArgs e)
        {
            this.visualizationLayer.ClearSelection(true);
        }

        private void visualizationLayer_MapShapeVisualizationRemoved(object sender, MapShapeOperationEventArgs e)
        {
            e.Visualization.MouseEnter -= Visualization_MouseEnter;
            e.Visualization.MouseLeave -= Visualization_MouseLeave;
        }
    }
}
